//==============================================================================
//
//                    uGMP̂悤ȃ`FbN{bNXv
//
//==============================================================================
//                                 Copyright 2001 Takeshi Okamoto(PAPY)
//                                 papy@hamal.freemail.ne.jp
//                                 http://homepage1.nifty.com/MADIA/ (Japanese)
//==============================================================================
//                                                                   Version 1.1
//==============================================================================
//
// Version 1.0     Ŋ@2001-01-22
//
//         1.1               2001-01-25
//                                  ...^uL[ɂtH[JẌړɑΉ
//
//@@̂ƂANZ[^L[ɂ͑ΉĂ܂(^^;
//  @@(Ή̎d킩莟@\ǉ܂B)
//==============================================================================
unit LCBox;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms ;

type
  TLozengeCheckBox = class(TCustomControl)
  private
    FChecked : Boolean ;
    FEnabled : Boolean;
    procedure SetTextBuf(Buffer: PChar);
    function  GetText: TCaption;
    procedure SetChecked(Value :Boolean);
    procedure SetText(const Value: TCaption);
    procedure SetEnbled(Value :Boolean);
    procedure WMSIZE(Var Msg :TWMSIZE);message WM_SIZE;
    procedure WMSETFOCUS(Var Msg :TWMSETFOCUS) ;message WM_SETFOCUS;
    procedure WMKIllFOCUS(Var Msg :TWMKillFOCUS) ;message WM_KillFOCUS;

  protected
    procedure Paint; override;
    procedure Click; override;
  public
    constructor Create(AOwner: TComponent); override;
    procedure CreateParams(var Params: TCreateParams); override;
  published
    property Checked : Boolean Read FChecked write SetChecked;
    property Caption: TCaption read GetText write SetText;
    property Enabled :Boolean read FEnabled write SetEnbled;
    property Color;
    property Cursor;
    property DragCursor;
    property DragMode;
    property Font;
    property Hint;
    property ParentColor;
    property ParentCtl3d;
    property ParentFont;
    property PopupMenu;
    property ShowHint;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnkeyDown;
    property OnkeyPress;
    property OnkeyUp;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('PAPY', [TLozengeCheckBox]);
end;

////////////////////////////////////////////////////////////////////////////////

/////////
procedure DisbleText(hDC: integer;TextRect :TRect ;MenuString : String );
Var
 TextColor   : integer;
 BkMode      : integer;
begin
  //ȑȌi[
  BkMode    :=GetBkMode (hDC);
  TextColor :=GetTextColor(hDC);

  SetBkMode(hDC,TRANSPARENT);

  TextRect.Left   := TextRect.Left+1;
  TextRect.Top    := TextRect.Top+1;
  TextRect.Right  := TextRect.Right+1;
  TextRect.Bottom := TextRect.Bottom+1;

  SetTextColor(hDC,GetSysColor(COLOR_BTNHIGHLIGHT));
  DrawText(hdc, Pchar(MenuString), -1, TextRect, DT_SINGLELINE Or  DT_VCENTER or 0 );

  TextRect.Left   := TextRect.Left-1;
  TextRect.Top    := TextRect.Top-1;
  TextRect.Right  := TextRect.Right-1;
  TextRect.Bottom := TextRect.Bottom-1;

  SetTextColor(hDC,GetSysColor(COLOR_BTNSHADOW));
  DrawText(hdc, Pchar(MenuString), -1, TextRect, DT_SINGLELINE Or DT_VCENTER or 0 ) ;

  //C
  SetBkMode(hDC,BkMode);
  SetTextColor(hDC,TextColor);

end;

///////////
constructor TLozengeCheckBox.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Width  := 170;
  Height := 30;
  FChecked :=False;
  FEnabled :=True;
  TabStop :=True;
end;

/////////
procedure TLozengeCheckBox.CreateParams(var Params: TCreateParams);
begin
   inherited CreateParams(Params);
   Params.Style  :=Params.Style or WS_TABSTOP ;
end;

/////////
procedure TLozengeCheckBox.Paint;
Var
 MyRect     : TRect;
 TextRect   : TRect;
 Triangle   : array[0..3] of  TPOINT  ;
 PenColor   : TColor;
begin

   Canvas.Brush.Color :=Color;
   Canvas.FillRect(Rect(0,0,width,Height));

   //Op`̏̒_
   Triangle[0].x :=Round(14/2)+4;
   Triangle[0].Y :=Round(Self.Height/2)-7;
   //Op`̍̒_
   Triangle[1].x :=4;
   Triangle[1].Y :=Round(Self.Height/2);
   //Op`̉̒_
   Triangle[2].x :=Round(14/2)+4 ;
   Triangle[2].Y :=Round(Self.Height/2)+7;
   //Op`̉E̒_
   Triangle[3].x :=14+4 ;
   Triangle[3].Y :=Round(Self.Height/2);

   //Op``
   Polygon (canvas.handle,Triangle[0] ,4 );

   PenColor :=Canvas.Pen.Color;

 if not FChecked then
 begin
   //Op`̍ɔ`
   Canvas.Pen.Color  :=ClWhite;
   Canvas.MoveTo(Triangle[0].X,Triangle[0].Y);
   Canvas.LineTo(Triangle[1].X,Triangle[1].Y);
   //Op`̉Eɔ`
   Canvas.MoveTo(Triangle[0].X,Triangle[0].Y);
   Canvas.LineTo(Triangle[3].X,Triangle[3].Y);
 end
 else
 begin
   //Op`̉Eɔ`
   Canvas.Pen.Color  :=ClWhite;
   Canvas.MoveTo(Triangle[3].X,Triangle[3].Y);
   Canvas.LineTo(Triangle[2].X,Triangle[2].Y);
   //Op`̍ɔ`
   Canvas.MoveTo(Triangle[2].X,Triangle[2].Y);
   Canvas.LineTo(Triangle[1].X,Triangle[1].Y);
 end;

   Canvas.Pen.Color:=  PenColor;
   Canvas.Font.Assign(Font);
   SetBkMode(Canvas.handle,TRANSPARENT);
   With MyRect do
   begin
     Top   :=Round(Self.Height/2)-7;
     Left  :=4;
     Bottom:=14+Top;
     Right :=14+Left;

           if Enabled then
           begin
               WIth TextRect  do
               begin
                   Top   :=Round(Self.Height/2)-(Canvas.TextHeight(Caption)div 2);
                   Left  :=MyRect.Right+MyRect.Left;
                   Bottom:=Canvas.TextHeight(Caption)+TextRect.Top;
                   Right :=Canvas.TextWidth(Caption)+TextREct.Left;
               end;
               DrawText(canvas.Handle,Pchar(Caption), -1, TextRect,DT_LEFT or DT_TABSTOP);

               //tH[JX̐ݒ
               if Focused then
                  if TextRect.Right<Self.Width then
                       DrawFocusRect(Canvas.Handle,
                               Rect(TextRect.Left-1,TextREct.Top,TextRect.Right,TextREct.Bottom))
                  else
                       DrawFocusRect(Canvas.Handle,
                               Rect(TextRect.Left-1,TextREct.Top,Self.Width,TextREct.Bottom))

           end
           else
           begin
               //قƂǑvȂ͂łtHgTCYɂĂ͔ɂꍇ̂ł̎͊eŏCĉB
                DisbleText(canvas.handle,
                              Rect(Right+5,Round(Self.Height/2)-(abs(Font.Height)div 2),
                                   Self.Width,Round(Self.Height/2)-(abs(Font.Height)div 2)+abs(Font.Height)),Caption);
           end;
  end;
end;

/////////
procedure TLozengeCheckBox.SetTextBuf(Buffer: PChar);
begin
  Perform(WM_SETTEXT, 0, Longint(Buffer));
  Perform(CM_TEXTCHANGED, 0, 0);
  paint;
end;

/////////
procedure TLozengeCheckBox.SetText(const Value: TCaption);
begin
  if GetText <> Value then SetTextBuf(PChar(Value));
end;

////////
function TLozengeCheckBox.GetText: TCaption;
var
  Len: Integer;
begin
  Len := GetTextLen;
  SetString(Result, PChar(nil), Len);
  if Len <> 0 then GetTextBuf(Pointer(Result), Len + 1);
end;

////////
procedure TLozengeCheckBox.SetChecked(Value :Boolean);
begin
 if Value <>FChecked then
 begin
  FChecked :=Value;

  paint;
 end;
end;

/////////
procedure TLozengeCheckBox.Click;
begin
  if FChecked  then
    FChecked :=False
  else
    FChecked :=True;

  SetFocus;
  Paint;
  inherited Click;
end;

/////////
procedure TLozengeCheckBox.SetEnbled(Value :Boolean);
begin
  if Value<>FEnabled then
  begin
    FEnabled :=Value;
    EnableWindow(Handle,Value);
    Paint;
  end;
end;

//bZ[W--------------------------------------------------------------------

/////////
procedure TLozengeCheckBox.WMSIZE(Var Msg :TWMSIZE);
begin
  Width  :=Msg.Width;
  height :=Msg.Height;
  Paint;
end;

/////////
procedure TLozengeCheckBox.WMSETFOCUS(Var Msg :TWMSETFOCUS) ;
begin
 Paint;
end;

/////////
procedure TLozengeCheckBox.WMKIllFOCUS(Var Msg :TWMKillFOCUS) ;
begin
 Paint;
end;





end.
