//==============================================================================
//
//                    uGMP̂悤ȃWI{^v
//
//==============================================================================
//                                 Copyright 2001 Takeshi Okamoto(PAPY)
//                                 papy@hamal.freemail.ne.jp
//                                 http://homepage1.nifty.com/MADIA/ (Japanese)
//==============================================================================
//                                                                   Version 1.1
//==============================================================================
//
// Version 1.0     Ŋ@2001-01-21
//         1.1               2001-01-25
//                                  ...^uL[ɂtH[JẌړɑΉ
//         1.2               2001-01-28
//                                  ...SCheckĂȂꍇ̂ŏCB
//
//@@̂ƂANZ[^L[ɂ͑ΉĂ܂(^^;
//  @@(Ή̎d킩莟@\ǉ܂B)
//==============================================================================
unit RRB;

interface

uses
  Windows, Messages, SysUtils, Classes, Controls, StdCtrls,Graphics,FOrms;

type
  TRectangleRadioButton = class(TCustomControl)
  private
    FChecked : Boolean ;
    FEnabled : Boolean;
    procedure SetTextBuf(Buffer: PChar);
    function  GetText: TCaption;
    procedure SetChecked(Value :Boolean);
    procedure SetText(const Value: TCaption);
    procedure SetEnbled(Value :Boolean);
    procedure TurnSiblingsOff;
    procedure WMSIZE(Var Msg :TWMSIZE);message WM_SIZE;
    procedure WMSETFOCUS(Var Msg :TWMSETFOCUS) ;message WM_SETFOCUS;
    procedure WMKIllFOCUS(Var Msg :TWMKillFOCUS) ;message WM_KillFOCUS;
  protected
    procedure Paint; override;
    procedure Click; override;
    procedure CreateParams(var Params: TCreateParams); override;
    procedure SetName(const Value: TComponentName); override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor Destroy; override;
  published
    property Checked : Boolean Read FChecked write SetChecked;
    property Caption: TCaption read GetText write SetText;
    property Enabled :Boolean read FEnabled write SetEnbled;
    property Color;
    property Cursor;
    property DragCursor;
    property DragMode;
    property Font;
    property Hint;
    property ParentColor;
    property ParentCtl3d;
    property ParentFont;
    property PopupMenu;
    property ShowHint;
    property Visible;
    property OnClick;
    property OnDblClick;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
    property OnkeyDown;
    property OnkeyPress;
    property OnkeyUp;



  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('PAPY', [TRectangleRadioButton]);
end;



////////////////////////////////////////////////////////////////////////////////



/////////
procedure DisbleText(hDC: integer;TextRect :TRect ;MenuString : String );
Var
 TextColor   : integer;
 BkMode      : integer;
begin
  //ȑȌi[
  BkMode    :=GetBkMode (hDC);
  TextColor :=GetTextColor(hDC);

  SetBkMode(hDC,TRANSPARENT);

  TextRect.Left   := TextRect.Left+1;
  TextRect.Top    := TextRect.Top+1;
  TextRect.Right  := TextRect.Right+1;
  TextRect.Bottom := TextRect.Bottom+1;

  SetTextColor(hDC,GetSysColor(COLOR_BTNHIGHLIGHT));
  DrawText(hdc, Pchar(MenuString), -1, TextRect, DT_SINGLELINE Or  DT_VCENTER or 0 );

  TextRect.Left   := TextRect.Left-1;
  TextRect.Top    := TextRect.Top-1;
  TextRect.Right  := TextRect.Right-1;
  TextRect.Bottom := TextRect.Bottom-1;

  SetTextColor(hDC,GetSysColor(COLOR_BTNSHADOW));
  DrawText(hdc, Pchar(MenuString), -1, TextRect, DT_SINGLELINE Or DT_VCENTER or 0 ) ;

  //C
  SetBkMode(hDC,BkMode);
  SetTextColor(hDC,TextColor);

end;

/////////
procedure TRectangleRadioButton.TurnSiblingsOff;
var
   I: Integer;
   Sibling: TControl;
begin
  if Parent <> nil then
  with Parent do
    for I := 0 to ControlCount - 1 do
    begin
        Sibling := Controls[I];
        if (Sibling <> Self) and (Sibling is TRectangleRadioButton) then
           TRectangleRadioButton(Sibling).Checked :=False;
    end;
end;

///////////
constructor TRectangleRadioButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Width  := 170;
  Height := 30;
  FChecked :=False;
  FEnabled :=True;
  TabStop :=True;
end;

/////////
procedure TRectangleRadioButton.CreateParams(var Params: TCreateParams);
begin
   inherited CreateParams(Params);
   Params.Style  :=Params.Style or WS_TABSTOP ;
end;

//////////
destructor TRectangleRadioButton.Destroy;
begin
  inherited Destroy;
end;

/////////
procedure TRectangleRadioButton.Paint;
Var
 MyRect     : TRect;
 TextRect   : TRect;
begin

   SetBkMode(Canvas.handle,TRANSPARENT);
   Canvas.Brush.Color :=Color;
   Canvas.FillRect(Rect(0,0,width,Height));
   Canvas.Font.Assign(Font);


      With MyRect do
      begin
        Top   :=Round(Self.Height/2)-7;
        Left  :=4;
        Bottom:=14+Top;
        Right :=14+Left;


                if Enabled then
                begin
                   WIth TextRect  do
                   begin
                     Top   :=Round(Self.Height/2)-(Canvas.TextHeight(Caption)div 2);
                     Left  :=MyRect.Right+MyRect.Left;
                     Bottom:=Canvas.TextHeight(Caption)+TextRect.Top;
                     Right :=Canvas.TextWidth(Caption)+TextREct.Left;
                   end;
                   DrawText(canvas.Handle,Pchar(Caption), -1, TextRect,DT_LEFT or DT_TABSTOP);

                   //tH[JX̐ݒ
                   if Focused then
                      if TextRect.Right<Self.Width then
                          DrawFocusRect(Canvas.Handle,
                               Rect(TextRect.Left-1,TextREct.Top,TextRect.Right,TextREct.Bottom))
                      else
                          DrawFocusRect(Canvas.Handle,
                               Rect(TextRect.Left-1,TextREct.Top,Self.Width,TextREct.Bottom))

                end
                else
                begin
                  //قƂǑvȂ͂łtHgTCYɂĂ͔ɂꍇ̂ł̎͊eŏCĉB
                  DisbleText(canvas.handle,
                              Rect(Right+5,Round(Self.Height/2)-(abs(Font.Height)div 2),
                                   Self.Width,Round(Self.Height/2)-(abs(Font.Height)div 2)+abs(Font.Height)),Caption);

                end;



       end;



    if not FChecked then
     DrawEdge(Canvas.Handle, MyRect, EDGE_RAISED, BF_RECT)
    else
     DrawEdge(Canvas.Handle, MyRect, EDGE_SUNKEN, BF_RECT)

end;

/////////
procedure TRectangleRadioButton.SetTextBuf(Buffer: PChar);
begin
  Perform(WM_SETTEXT, 0, Longint(Buffer));
  Perform(CM_TEXTCHANGED, 0, 0);
  paint;
end;

/////////
procedure TRectangleRadioButton.SetText(const Value: TCaption);
begin
  if GetText <> Value then SetTextBuf(PChar(Value));
end;

////////
function TRectangleRadioButton.GetText: TCaption;
var
  Len: Integer;
begin
  Len := GetTextLen;
  SetString(Result, PChar(nil), Len);
  if Len <> 0 then GetTextBuf(Pointer(Result), Len + 1);
end;

/////////
procedure TRectangleRadioButton.SetName(const Value: TComponentName);
var
  ChangeText: Boolean;
begin
  ChangeText := (csSetCaption in ControlStyle) and (Name = Text) and
    ((Owner = nil) or not (Owner is TControl) or
    not (csLoading in TControl(Owner).ComponentState));
  inherited SetName(Value);
  if ChangeText then
  begin
   Caption := Value;
    if not (csDesigning  in ComponentState) then   Paint;
  end;   
end;


////////
procedure TRectangleRadioButton.SetChecked(Value :Boolean);
begin
 if Value <>FChecked then
 begin
  FChecked :=Value;
  if Value then TurnSiblingsOff ;
  paint;
 end;
end;

/////////
procedure TRectangleRadioButton.Click;
begin
  TurnSiblingsOff;
  FChecked :=True;
  
  SetFocus;
  Paint;
  inherited Click;
end;

/////////
procedure TRectangleRadioButton.SetEnbled(Value :Boolean);
begin
  if Value<>FEnabled then
  begin
    FEnabled :=Value;
    EnableWindow(Handle,Value);
    Paint;
  end;
end;

//bZ[W--------------------------------------------------------------------


/////////
procedure TRectangleRadioButton.WMSIZE(Var Msg :TWMSIZE);
begin
  Width  :=Msg.Width;
  height :=Msg.Height;
  Paint;
end;

/////////
procedure TRectangleRadioButton.WMSETFOCUS(Var Msg :TWMSETFOCUS) ;
begin
 Paint;
end;

/////////
procedure TRectangleRadioButton.WMKIllFOCUS(Var Msg :TWMKillFOCUS) ;
begin
 Paint;
end;

end.
