//==============================================================================
//
//                      uEChEv
//
//==============================================================================
//                                 Copyright 2000 Takeshi Okamoto(PAPY)
//                                 papy@hamal.freemail.ne.jp
//                                 http://homepage1.nifty.com/MADIA/ (Japanese)
//==============================================================================
//                                                                   Version 1.2
//==============================================================================
//
// Version 1.00     J@2000-09
//         1.1              2000-09-30
//         1.2              2000-01-16
//                               ݌vɃR|uœɂȂ悤ɂB
//==============================================================================


unit Transparent;

interface

uses
  Windows, Messages, SysUtils, Classes,  Controls, Forms ;

type
  TTransparent = class(TComponent)
  private
    { Private 錾 }

     MyOwner  : TForm   ;
     Rgn,Rgn2 : integer ;  //̈̃nh
     Flag     : Boolean ;
     procedure   TransparentForm;

  protected
    { Protected 錾 }
    procedure  Loaded; override;
  public
    { Public 錾 }

     constructor Create(AOwner: TComponent); override;
     destructor  Destroy; override;

  published
    { Published 錾 }
end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('PAPY', [TTransparent]);
 end;


////////////////////////////////////////////////////////////////////////////////

///////////
constructor TTransparent.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  with AOwner as TForm do
  MyOwner := TForm(AOwner);
end;

///////////
destructor TTransparent.Destroy;
begin
  DeleteObject(Rgn) ;
  DeleteObject(Rgn2) ;
  inherited Destroy;
end;

///////////
procedure TTransparent.TransparentForm ;
var
ChildControl : TControl;
i,W,T      : integer;
begin

if not Flag then
begin

     W := ((MyOwner.Width -  MyOwner.ClientWidth) div 2 )  ;
     T :=  (MyOwner.Height -  MyOwner.ClientHeight) - W   ;

    For  i := 0 to MyOwner.ControlCount -1 do
    begin

        ChildControl :=MyOwner.Controls[i] ;

        Rgn2 := CreateRectRgn
                   (ChildControl.Left+W ,
                     ChildControl.Top+T ,
                      ChildControl.Left +ChildControl.Width+W ,
                       ChildControl.Top+ChildControl.Height+T   )  ;

        If Rgn <> 0 Then
            CombineRgn(Rgn, Rgn, Rgn2, 2)
        else
            Rgn := Rgn2;


    end;

          SetWindowRgn(MyOwner.Handle, Rgn, True);

          Flag :=True;

end;

end;
/////////
procedure TTransparent.Loaded;
begin
 TransparentForm;
end;



end.
