//==============================================================================
//
//                           uOp`{^v
//
//==============================================================================
//                                 Copyright 2001 Takeshi Okamoto(PAPY)
//                                 papy@hamal.freemail.ne.jp
//                                 http://homepage1.nifty.com/MADIA/ (Japanese)
//==============================================================================
//                                                                   Version 1.1
//==============================================================================
//
// Version 1.0     Ŋ@2001-01-18
//         1.1               2001-01-21 ...}EXñCxg̃oOC
//
//==============================================================================
unit TB;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, StdCtrls,ExtCtrls;

type
  TTaiangleStyle =(tsTop,tsLeft,tsBottom,tsRight);
  TTriangleButton = class(TCustomControl)
  private
    Timer    : TTimer;
    ClickOK  : Boolean;
    Pushed   : Boolean;
    MyOwner  : TForm   ;
    FStyle    : TTaiangleStyle;
    procedure WMSIZE(Var Msg : TWMSIZE);message WM_SIZE;
    procedure WMLBUTTONDOWN(Var Msg : TWMLBUTTONDOWN);message WM_LBUTTONDOWN;
    procedure WMLBUTTONDBLCLK(Var Msg : TWMLBUTTONDBLCLK);message WM_LBUTTONDBLCLK;
    procedure WMLBUTTONUP(Var Msg : TWMLBUTTONUP);message WM_LBUTTONUP;
    procedure WMMBUTTONDBLCLK(var Msg: TWMMBUTTONDBLCLK); message WM_MBUTTONDBLCLK  ;
    procedure WMMBUTTONDOWN(var Msg: TWMMBUTTONDOWN); message WM_MBUTTONDOWN;
    procedure WMMBUTTONUP(var Msg: TWMMBUTTONUP); message  WM_MBUTTONUP;
    procedure WMRBUTTONDBLCLK(var Msg: TWMRBUTTONDBLCLK);message WM_RBUTTONDBLCLK;
    procedure WMRBUTTONDOWN(var Msg: TWMRBUTTONDOWN); message WM_RBUTTONDOWN ;
    procedure WMRBUTTONUP(var Msg: TWMRBUTTONUP); message WM_RBUTTONUP  ;
    procedure WMMOUSEMOVE(var Msg: TWMMOUSEMOVE); message  WM_MOUSEMOVE ;
    procedure OnTimerEvents(Sender: TObject) ;
    procedure SetStyle(Value :TTaiangleStyle);
  protected
    procedure CreateWnd; override;
    procedure Paint    ; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;

  published
    property Style :TTaiangleStyle read FStyle Write SetStyle;
    property Color ;
    property DragCursor;
    property DragMode;
    property Enabled;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
 //   property TabOrder;
 //   property TabStop ;
    property Visible;
    property OnClick;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;
 end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('PAPY', [TTriangleButton]);
end;

////////////////////////////////////////////////////////////////////////////////

////////
function TriangleDraw(hWidth,hHeight : integer;BackColor,BackgrandColor :TColor;Style : TTaiangleStyle):integer;
var
 Triangle   : array[0..2] of  TPOINT  ;
 BMP        : TBitmap;
begin
    BMP :=TBitmap.Create;
    BMP.Width  :=hWidth;
    BMP.Height :=hHeight;
 Case Style  of
   tsTop :  begin
                 //Op`̏̒_
                 Triangle[0].x :=Round(hWidth/2);
                 Triangle[0].Y :=0;
                 //Op`̍̒_
                 Triangle[1].x :=0;
                 Triangle[1].Y :=hHeight;
                 //Op`̉E̒_
                 Triangle[2].x :=hWidth ;
                 Triangle[2].Y :=hHeight;

                 //obNJ[`(݌v̈)
                 BMP.Canvas.Brush.Color :=BackgrandColor;
                 BMP.Canvas.FillRect(REct(0,0,BMP.Width,BMP.Height));

                 //Op``
                 BMP.Canvas.Brush.Color  :=BackColor;
                 Polygon (BMP.canvas.handle,Triangle[0] ,3 );

                 //Op`̍ɔ`
                 BMP.Canvas.Pen.Color  :=ClWhite;
                 BMP.Canvas.MoveTo(Triangle[0].X,Triangle[0].Y);
                 BMP.Canvas.LineTo(Triangle[1].X,Triangle[1].Y);
                 BMP.Canvas.MoveTo(Triangle[0].X+1,Triangle[0].Y-1);
                 BMP.Canvas.LineTo(Triangle[1].X+1,Triangle[1].Y-1);

                 //Op`̒ӂɍ
                 BMP.Canvas.Pen.Color  :=ClBlack;
                 BMP.Canvas.MoveTo(Triangle[1].X,Triangle[1].Y-1);
                 BMP.Canvas.LineTo(Triangle[2].X,Triangle[2].Y-1);
                // BMP.Canvas.MoveTo(Triangle[1].X,Triangle[1].Y-2);
                // BMP.Canvas.LineTo(Triangle[2].X,Triangle[2].Y-2);

                 //E̕ӂɐ`
                 BMP.Canvas.MoveTo(Triangle[0].X,Triangle[0].Y);
                 BMP.Canvas.LineTo(Triangle[2].X-1,Triangle[2].Y);

           end;

  tsLeft: begin
                 //Op`̏̒_
                 Triangle[0].x :=hWidth;
                 Triangle[0].Y :=0;
                 //Op`̍̒_
                 Triangle[1].x :=0;
                 Triangle[1].Y :=Round(hHeight/2);
                 //Op`̉E̒_
                 Triangle[2].x :=hWidth ;
                 Triangle[2].Y :=hHeight;

                 //obNJ[`(݌v̈)
                 BMP.Canvas.Brush.Color :=BackgrandColor;
                 BMP.Canvas.FillRect(REct(0,0,BMP.Width,BMP.Height));

                 //Op``
                 BMP.Canvas.Brush.Color  :=BackColor;
                 Polygon (BMP.canvas.handle,Triangle[0] ,3 );

                 //Op`̍ɔ`
                 BMP.Canvas.Pen.Color  :=ClWhite;
                 BMP.Canvas.MoveTo(Triangle[0].X,Triangle[0].Y);
                 BMP.Canvas.LineTo(Triangle[1].X,Triangle[1].Y);
                 BMP.Canvas.MoveTo(Triangle[0].X-1,Triangle[0].Y+1);
                 BMP.Canvas.LineTo(Triangle[1].X+1,Triangle[1].Y-1);

                 //E̕ӂɐ`
                 BMP.Canvas.Pen.Color  :=ClBlack;
                 BMP.Canvas.MoveTo(hWidth-1,0);
                 BMP.Canvas.LineTo(hWidth-1,hHeight);

           end;

  tsBottom: begin
                 //Op`̉̒_
                 Triangle[0].x :=Round(hWidth/2);
                 Triangle[0].Y :=hHeight;
                 //Op`̍̒_
                 Triangle[1].x :=0;
                 Triangle[1].Y :=0;
                 //Op`̉E̒_
                 Triangle[2].x :=hWidth ;
                 Triangle[2].Y :=0;

                 //obNJ[`(݌v̈)
                 BMP.Canvas.Brush.Color :=BackgrandColor;
                 BMP.Canvas.FillRect(REct(0,0,BMP.Width,BMP.Height));

                 //Op``
                 BMP.Canvas.Brush.Color  :=BackColor;
                 Polygon (BMP.canvas.handle,Triangle[0] ,3 );

                 //Op`̍ɔ`
                 BMP.Canvas.Pen.Color  :=ClWhite;
                 BMP.Canvas.MoveTo(Triangle[0].X,Triangle[0].Y);
                 BMP.Canvas.LineTo(Triangle[1].X,Triangle[1].Y);
                 BMP.Canvas.MoveTo(Triangle[0].X+1,Triangle[0].Y+1);
                 BMP.Canvas.LineTo(Triangle[1].X+1,Triangle[1].Y+1);

                 //Op`̉Eӂɍ
                 BMP.Canvas.Pen.Color  :=ClBlack;
                 BMP.Canvas.MoveTo(Triangle[0].X-1,Triangle[0].Y+1);
                 BMP.Canvas.LineTo(Triangle[2].X-1,Triangle[2].Y);

                 //Op`̒ӂɐ`
               //  BMP.Canvas.MoveTo(Triangle[1].X+1,Triangle[1].Y+1);
                // BMP.Canvas.LineTo(Triangle[2].X-1,Triangle[2].Y+1);

            end;

  tsRight:  begin
                 //Op`̉E̒_
                 Triangle[0].x :=hWidth;
                 Triangle[0].Y :=Round(hHeight/2);
                 //Op`̏̒_
                 Triangle[1].x :=0;
                 Triangle[1].Y :=0;
                 //Op`̉̒_
                 Triangle[2].x :=0;
                 Triangle[2].Y :=hHeight;

                 //obNJ[`(݌v̈)
                 BMP.Canvas.Brush.Color :=BackgrandColor;
                 BMP.Canvas.FillRect(REct(0,0,BMP.Width,BMP.Height));

                 //Op``
                 BMP.Canvas.Brush.Color  :=BackColor;
                 Polygon (BMP.canvas.handle,Triangle[0] ,3 );

                 //Op`̍ɔ`
                 BMP.Canvas.Pen.Color  :=ClWhite;
                 BMP.Canvas.MoveTo(Triangle[0].X,Triangle[0].Y);
                 BMP.Canvas.LineTo(Triangle[1].X,Triangle[1].Y);
                 BMP.Canvas.MoveTo(Triangle[1].X,Triangle[1].Y);
                 BMP.Canvas.LineTo(Triangle[0].X,Triangle[0].Y+1);

                 //Op`̒ӂɍ
                 BMP.Canvas.Pen.Color  :=ClBlack;
                 BMP.Canvas.MoveTo(Triangle[1].X,Triangle[1].Y-1);
                 BMP.Canvas.LineTo(Triangle[2].X,Triangle[2].Y-1);
                 BMP.Canvas.MoveTo(Triangle[1].X,Triangle[1].Y-2);
                 BMP.Canvas.LineTo(Triangle[2].X,Triangle[2].Y-2);

                 //E̕ӂɐ`
                 BMP.Canvas.MoveTo(Triangle[0].X,Triangle[0].Y);
                 BMP.Canvas.LineTo(Triangle[2].X-1,Triangle[2].Y);

            end;

  end;




    Result := BMP.ReleaseHandle;
    BMP.Free;
end;

////////
function TrianglePushedDraw(hWidth,hHeight : integer;BackColor,BackgrandColor :TColor ;Style : TTaiangleStyle):integer;
var
 Triangle   : array[0..2] of  TPOINT  ;
 BMP : TBitmap;
begin
    BMP :=TBitmap.Create;
    BMP.Width  :=hWidth;
    BMP.Height :=hHeight;

 Case Style  of
 tsTop :     begin
                   //̒_
                   Triangle[0].x :=Round(hWidth/2);
                   Triangle[0].Y :=0;
                   //̒_
                   Triangle[1].x :=0;
                   Triangle[1].Y :=hHeight;
                   //E̒_
                   Triangle[2].x :=hWidth ;
                   Triangle[2].Y :=hHeight;

                   //obNJ[`(݌v̈)
                   BMP.Canvas.Brush.Color :=BackgrandColor;
                   BMP.Canvas.FillRect(REct(0,0,BMP.Width,BMP.Height));

                   //Op``
                   BMP.Canvas.Brush.Style  :=bsSolid;
                   BMP.Canvas.Brush.Color  :=clDkGray	;
                   Polygon (BMP.canvas.handle,Triangle[0] ,3 );

                   //Op`̒ӂɔ
                   BMP.Canvas.Pen.Color  :=ClWhite;
                   BMp.Canvas.MoveTo(Triangle[1].X,Triangle[1].Y-1);
                   BMP.Canvas.LineTo(Triangle[2].X,Triangle[2].Y-1);

                 //  BMp.Canvas.MoveTo(Triangle[1].X,Triangle[1].Y-2);
                 //  BMP.Canvas.LineTo(Triangle[2].X,Triangle[2].Y-2);
             end;
  tsLeft:    begin
                  //Op`̏̒_
                  Triangle[0].x :=hWidth;
                  Triangle[0].Y :=0;
                  //Op`̍̒_
                  Triangle[1].x :=0;
                  Triangle[1].Y :=Round(hHeight/2);
                  //Op`̉E̒_
                  Triangle[2].x :=hWidth ;
                  Triangle[2].Y :=hHeight;

                  //obNJ[`(݌v̈)
                  BMP.Canvas.Brush.Color :=BackgrandColor;
                  BMP.Canvas.FillRect(REct(0,0,BMP.Width,BMP.Height));

                  //Op``
                  BMP.Canvas.Brush.Style  :=bsSolid;
                  BMP.Canvas.Brush.Color  :=clDkGray	;
                  Polygon (BMP.canvas.handle,Triangle[0] ,3 );

                  BMP.Canvas.Pen.Color  :=ClWhite;
                 // BMp.Canvas.MoveTo(Triangle[2].X,Triangle[2].Y);
                 // BMP.Canvas.LineTo(Triangle[1].X,Triangle[1].Y);
                 // BMp.Canvas.MoveTo(Triangle[2].X-1,Triangle[2].Y-1);
                 // BMP.Canvas.LineTo(Triangle[1].X+1,Triangle[1].Y-1);

                  BMp.Canvas.MoveTo(hWidth-1,0);
                  BMP.Canvas.LineTo(hwidth-1,hHeight);


             end;


  tsBottom:  begin
                  //Op`̉̒_
                  Triangle[0].x :=Round(hWidth/2);
                  Triangle[0].Y :=hHeight;
                  //Op`̍̒_
                  Triangle[1].x :=0;
                  Triangle[1].Y :=0;
                  //Op`̉E̒_
                  Triangle[2].x :=hWidth ;
                  Triangle[2].Y :=0;

                  //obNJ[`(݌v̈)
                  BMP.Canvas.Brush.Color :=BackgrandColor;
                  BMP.Canvas.FillRect(REct(0,0,BMP.Width,BMP.Height));

                  //Op``
                  BMP.Canvas.Brush.Style  :=bsSolid;
                  BMP.Canvas.Brush.Color  :=clDkGray	;
                  Polygon (BMP.canvas.handle,Triangle[0] ,3 );

                  //Op`̒ӂɔ
                  BMP.Canvas.Pen.Color  :=ClWhite;
                  BMp.Canvas.MoveTo(Triangle[1].X,Triangle[1].Y);
                  BMP.Canvas.LineTo(Triangle[2].X,Triangle[2].Y);
                //  BMp.Canvas.MoveTo(Triangle[1].X+1,Triangle[1].Y+1);
                //  BMP.Canvas.LineTo(Triangle[2].X-1,Triangle[2].Y+1);

             end;
  tsRight:   begin

                  //Op`̉E̒_
                  Triangle[0].x :=hWidth;
                  Triangle[0].Y :=Round(hHeight/2);
                  //Op`̏̒_
                  Triangle[1].x :=0;
                  Triangle[1].Y :=0;
                  //Op`̉̒_
                  Triangle[2].x :=0;
                  Triangle[2].Y :=hHeight;

                  //obNJ[`(݌v̈)
                  BMP.Canvas.Brush.Color :=BackgrandColor;
                  BMP.Canvas.FillRect(REct(0,0,BMP.Width,BMP.Height));

                  //Op``
                  BMP.Canvas.Brush.Style  :=bsSolid;
                  BMP.Canvas.Brush.Color  :=clDkGray	;
                  Polygon (BMP.canvas.handle,Triangle[0] ,3 );

                  //Op`̒ӂɔ
                  BMP.Canvas.Pen.Color  :=ClWhite;
                  BMp.Canvas.MoveTo(0,0);
                  BMP.Canvas.LineTo(0,hHeight);
             end;

  end;


    Result := BMP.ReleaseHandle;
    BMP.Free;
end;
///////////
constructor TTriangleButton.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  ControlStyle := [csDoubleClicks];
  Width   := 25;
  Height  := 25;
  Color   := clSilver;
  Pushed  := False;
  ClickOK := False;
  FStyle  := tsTop;
  Timer   := TTimer.Create(Self);
  Timer.Interval := 100;
  Timer.OnTimer  := OnTimerEvents;
  Timer.Enabled  := False;

  with AOwner as TForm do
  MyOwner := TForm(AOwner);

end;

///////////
destructor  TTriangleButton.Destroy;
begin
  Timer.Free;
  inherited Destroy;
end;

/////////
procedure TTriangleButton.CreateWnd;
var
 hRGN       : integer;
 hDC_Button : Integer;
 Triangle   : array[0..2] of  TPOINT  ;
 ButtonRect : TRect;
begin
 inherited CreateWnd;

 //݌vɃ[WƂ܂`iHjȂŁEEE
 if not (csDesigning in ComponentState) then
 begin
     //foCXReLXg擾
     hDC_Button:= GetWindowDC(Handle);
     ButtonRect :=RECT(0,0,Width,Height)  ;
   Case FStyle of
     tsTop   : begin
                  Triangle[0].x :=Round(Width / 2);
                  Triangle[0].Y :=0;
                  Triangle[1].x :=0;
                  Triangle[1].Y :=Height;
                  Triangle[2].x :=Width ;
                  Triangle[2].Y :=Height;
               end;      
      tsLeft : begin
                 //Op`̏̒_
                 Triangle[0].x :=Width;
                 Triangle[0].Y :=0;
                 //Op`̍̒_
                 Triangle[1].x :=0;
                 Triangle[1].Y :=Round(Height/2);
                 //Op`̉E̒_
                 Triangle[2].x :=Width ;
                 Triangle[2].Y :=Height;
               end;
      tsBottom:begin
                 //Op`̉̒_
                 Triangle[0].x :=Round(Width/2);
                 Triangle[0].Y :=Height;
                 //Op`̍̒_
                 Triangle[1].x :=0;
                 Triangle[1].Y :=0;
                 //Op`̉E̒_
                 Triangle[2].x :=Width ;
                 Triangle[2].Y :=0;
               end;
       tsRight:begin
                 //Op`̉E̒_
                 Triangle[0].x :=Width;
                 Triangle[0].Y :=Round(Height/2);
                 //Op`̏̒_
                 Triangle[1].x :=0;
                 Triangle[1].Y :=0;
                 //Op`̉̒_
                 Triangle[2].x :=0;
                 Triangle[2].Y :=Height;
               end;
    end;

     hRGN:=CreatePolygonRgn(Triangle[0] ,3 , WINDING);
     ReleaseDC(Handle,hDC_Button);

     //EChE̕`̈ݒ肷
     SetWindowRgn(Handle, hRGN, True);
 end;

  PAINT;
end;

/////////
procedure TTriangleButton.PAINT;
Var
 BMP :TBitmap;
 hDC_Button :integer;
begin

  BMP :=TBitmap.Create;
  if not Pushed then
    BMP.Handle := TriangleDraw(Width,Height,Color,MyOwner.Color,Fstyle)
  else
    BMP.Handle := TrianglePushedDraw(Width,Height,Color,MyOwner.Color,Fstyle);

  hDC_Button:= GetWindowDC(Handle);
  Bitblt(hDC_Button,0,0,Width,Height,BMP.canvas.handle,0,0,SRCCOPY);
  ReleaseDC(Handle,hDC_Button);

  BMP.Free;

end;

/////////
procedure TTriangleButton.SetStyle(Value :TTaiangleStyle);
begin
  if Value=FStyle then Exit;
  FStyle :=Value;
  Paint;
end;

/////////
procedure TTriangleButton.OnTimerEvents(Sender: TObject) ;
var
Poi      : TPoint;
begin
  GetCursorPos(Poi);
  Poi := Self.ScreenToClient(Poi);
  if (Poi.X <0 ) or (Poi.Y<0) or (Poi.X>Self.Width) or (Poi.Y>Self.Height)   then
  begin
    Pushed :=False;
    ClickOK :=False;
    Paint;
    Timer.Enabled :=False;
 end;

end;

//bZ[W--------------------------------------------------------------------

/////////
procedure TTriangleButton.WMSIZE(Var Msg : TWMSIZE);
begin
  if (Msg.Width <>Width) or (Msg.Height<>Height) then
  begin
   Self.SetBounds(Left,Top,Msg.Width,Msg.Height);
   RecreateWnd;
  end;
end;

/////////
procedure TTriangleButton.WMLBUTTONDOWN(Var Msg : TWMLBUTTONDOWN);
Var
 Shift : TShiftState ;
begin
  if (csDesigning in ComponentState) then EXit;
  Pushed :=True;
  Paint;
  Timer.Enabled :=True;
  ClickOK :=True;
 //ssAltssDouble͏ȗĒ܂B
 if Msg.Keys=MK_CONTROL	 then  Shift:= Shift+[ssCtrl];
 if Msg.Keys=MK_LBUTTON	 then  Shift:= Shift+[ssLeft]	;
 if Msg.Keys=MK_MBUTTON	 then  Shift:= Shift+[ssMiddle]	;
 if Msg.Keys=MK_RBUTTON	 then  Shift:= Shift+[ssRight]	;
 if Msg.Keys=MK_SHIFT	 then  Shift:= Shift+[ssShift]	;
 Self.MouseDown(mbLeft,Shift,Msg.XPos,Msg.YPos);
end;

/////////
procedure TTriangleButton.WMLBUTTONDBLCLK(Var Msg : TWMLBUTTONDBLCLK);
Var
 Shift : TShiftState ;
begin
  if (csDesigning in ComponentState) then EXit;
  Pushed :=True;
  Paint;
  Timer.Enabled :=True;
  ClickOK :=True;
  //ssAltssDouble͏ȗĒ܂B
  if Msg.Keys=MK_CONTROL	 then  Shift:= Shift+[ssCtrl];
  if Msg.Keys=MK_LBUTTON	 then  Shift:= Shift+[ssLeft]	;
  if Msg.Keys=MK_MBUTTON	 then  Shift:= Shift+[ssMiddle]	;
  if Msg.Keys=MK_RBUTTON	 then  Shift:= Shift+[ssRight]	;
  if Msg.Keys=MK_SHIFT	 then  Shift:= Shift+[ssShift]	;
  Self.MouseDown(mbLeft,Shift,Msg.XPos,Msg.YPos);
end;

/////////
procedure TTriangleButton.WMLBUTTONUP(Var Msg : TWMLBUTTONUP);
Var
 Shift : TShiftState ;
begin
 if (csDesigning in ComponentState) then EXit;
 Pushed :=False;
 Paint;
 Timer.Enabled :=False;
 if   ClickOK  then
 begin
   Click;
   ClickOK :=False;
 end;
 //ssAltssDouble͏ȗĒ܂B
 if Msg.Keys=MK_CONTROL	 then  Shift:= Shift+[ssCtrl];
 if Msg.Keys=MK_LBUTTON	 then  Shift:= Shift+[ssLeft]	;
 if Msg.Keys=MK_MBUTTON	 then  Shift:= Shift+[ssMiddle]	;
 if Msg.Keys=MK_RBUTTON	 then  Shift:= Shift+[ssRight]	;
 if Msg.Keys=MK_SHIFT	 then  Shift:= Shift+[ssShift]	;
 Self.MouseUp(mbLeft,Shift,Msg.XPos,Msg.YPos);
end;

/////////
procedure TTriangleButton.WMMBUTTONDBLCLK(var Msg: TWMMBUTTONDBLCLK);
Var
 Shift : TShiftState ;
begin
 //ssAltssDouble͏ȗĒ܂B
 if Msg.Keys=MK_CONTROL	 then  Shift:= Shift+[ssCtrl];
 if Msg.Keys=MK_LBUTTON	 then  Shift:= Shift+[ssLeft]	;
 if Msg.Keys=MK_MBUTTON	 then  Shift:= Shift+[ssMiddle]	;
 if Msg.Keys=MK_RBUTTON	 then  Shift:= Shift+[ssRight]	;
 if Msg.Keys=MK_SHIFT	 then  Shift:= Shift+[ssShift]	;
 Self.MouseUp(mbMiddle,Shift,Msg.XPos,Msg.YPos);
end;

/////////
procedure TTriangleButton.WMMBUTTONDOWN(var Msg: TWMMBUTTONDOWN);
Var
 Shift : TShiftState ;
begin
 //ssAltssDouble͏ȗĒ܂B
 if Msg.Keys=MK_CONTROL	 then  Shift:= Shift+[ssCtrl];
 if Msg.Keys=MK_LBUTTON	 then  Shift:= Shift+[ssLeft]	;
 if Msg.Keys=MK_MBUTTON	 then  Shift:= Shift+[ssMiddle]	;
 if Msg.Keys=MK_RBUTTON	 then  Shift:= Shift+[ssRight]	;
 if Msg.Keys=MK_SHIFT	 then  Shift:= Shift+[ssShift]	;
 Self.MouseDown(mbMiddle,Shift,Msg.XPos,Msg.YPos);
end;

/////////
procedure TTriangleButton.WMMBUTTONUP(var Msg: TWMMBUTTONUP);
Var
 Shift : TShiftState ;
begin
 //ssAltssDouble͏ȗĒ܂B
 if Msg.Keys=MK_CONTROL	 then  Shift:= Shift+[ssCtrl];
 if Msg.Keys=MK_LBUTTON	 then  Shift:= Shift+[ssLeft]	;
 if Msg.Keys=MK_MBUTTON	 then  Shift:= Shift+[ssMiddle]	;
 if Msg.Keys=MK_RBUTTON	 then  Shift:= Shift+[ssRight]	;
 if Msg.Keys=MK_SHIFT	 then  Shift:= Shift+[ssShift]	;
 Self.MouseUp(mbMiddle,Shift,Msg.XPos,Msg.YPos);
end;

/////////
procedure TTriangleButton.WMRBUTTONDBLCLK(var Msg: TWMRBUTTONDBLCLK);
Var
 Shift : TShiftState ;
begin
 //ssAltssDouble͏ȗĒ܂B
 if Msg.Keys=MK_CONTROL	 then  Shift:= Shift+[ssCtrl];
 if Msg.Keys=MK_LBUTTON	 then  Shift:= Shift+[ssLeft]	;
 if Msg.Keys=MK_MBUTTON	 then  Shift:= Shift+[ssMiddle]	;
 if Msg.Keys=MK_RBUTTON	 then  Shift:= Shift+[ssRight]	;
 if Msg.Keys=MK_SHIFT	 then  Shift:= Shift+[ssShift]	;
 Self.MouseDown(mbRight,Shift,Msg.XPos,Msg.YPos);
end;

/////////
procedure TTriangleButton.WMRBUTTONDOWN(var Msg: TWMRBUTTONDOWN);
Var
 Shift : TShiftState ;
begin
 //ssAltssDouble͏ȗĒ܂B
 if Msg.Keys=MK_CONTROL	 then  Shift:= Shift+[ssCtrl];
 if Msg.Keys=MK_LBUTTON	 then  Shift:= Shift+[ssLeft]	;
 if Msg.Keys=MK_MBUTTON	 then  Shift:= Shift+[ssMiddle]	;
 if Msg.Keys=MK_RBUTTON	 then  Shift:= Shift+[ssRight]	;
 if Msg.Keys=MK_SHIFT	 then  Shift:= Shift+[ssShift]	;
 Self.MouseDown(mbRight,Shift,Msg.XPos,Msg.YPos);
end;

/////////
procedure TTriangleButton.WMRBUTTONUP(var Msg: TWMRBUTTONUP);
Var
 Shift : TShiftState ;
begin
 //ssAltssDouble͏ȗĒ܂B
 if Msg.Keys=MK_CONTROL	 then  Shift:= Shift+[ssCtrl];
 if Msg.Keys=MK_LBUTTON	 then  Shift:= Shift+[ssLeft]	;
 if Msg.Keys=MK_MBUTTON	 then  Shift:= Shift+[ssMiddle]	;
 if Msg.Keys=MK_RBUTTON	 then  Shift:= Shift+[ssRight]	;
 if Msg.Keys=MK_SHIFT	 then  Shift:= Shift+[ssShift]	;
 Self.MouseUp(mbRight,Shift,Msg.XPos,Msg.YPos);
end;

/////////
procedure TTriangleButton.WMMOUSEMOVE(var Msg: TWMMOUSEMOVE);
Var
 Shift : TShiftState ;
begin
 //ssAltssDouble͏ȗĒ܂B
 if Msg.Keys=MK_CONTROL	 then  Shift:= Shift+[ssCtrl];
 if Msg.Keys=MK_LBUTTON	 then  Shift:= Shift+[ssLeft]	;
 if Msg.Keys=MK_MBUTTON	 then  Shift:= Shift+[ssMiddle]	;
 if Msg.Keys=MK_RBUTTON	 then  Shift:= Shift+[ssRight]	;
 if Msg.Keys=MK_SHIFT	 then  Shift:= Shift+[ssShift]	;
  Self.MouseMOve(Shift,Msg.XPos,Msg.YPos);
end;





end.
