//==============================================================================
//
//                       uJ[vOXo[v
//
//==============================================================================
//                                 Copyright 2001 Takeshi Okamoto(PAPY)
//                                 papy@hamal.freemail.ne.jp
//                                 http://homepage1.nifty.com/MADIA/ (Japanese)
//==============================================================================
//                                                                   Version 1.0
//==============================================================================
//
// Version 1.0      Ŋ@2001-01-19
//
//==============================================================================
//  ̃R|Comctl32.dllVer4.71ȏłȂƓv܂B
//  ܂AWin98WɃCXg[ĂłComctl32.dll̃o[W
//  Ver4.71łB
//==============================================================================
unit CPB;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, ComCtrls,Forms,
//萔Ȃǂ̒`t@C
  CPB_Header   ;

type
  TProgressStyle = (psVertical,psHorizontal);
  TColorProgressBar = class(TWinControl)
  private
    hProg          : integer;
    FBackColor     : TColor ;
    FBArColor      : TColor ;
    FHookWndProc   : Pointer;
    FAddress       : Pointer;
    FMin           : Word;
    FMax           : Word;
    FStep          : Word;
    FPosition      : Word;
    FSmooth        : Boolean;
    FProgressStyle   : TProgressStyle;
    procedure SetMin(Value: Word);
    procedure SetMax(Value: Word);
    procedure SetPosition(Value: Word);
    procedure SetStep(Value: Word);
    procedure SetSmooth(Value: Boolean);
    function  GetMin: Word;
    function  GetMax: Word;
    function  GetPosition: Word  ;
    procedure SetParams(AMin, AMax: Word);
    procedure HookWndProc( var Msg:TMessage );
    procedure SetBackColor(Value :TColor);
    procedure SetBarColor(Value :TColor);
    procedure SetProgressStyle(Value :TProgressStyle);
    procedure WMSize(var Msg: TWMSize); message WM_SIZE;
    procedure WMLBUTTONDBLCLK(var Msg: tWMLBUTTONDBLCLK);
    procedure WMLBUTTONDOWN(var Msg: TWMLBUTTONDOWN);
    procedure WMLBUTTONUP(var Msg: TWMLBUTTONUP);
    procedure WMMBUTTONDBLCLK(var Msg: TWMMBUTTONDBLCLK);
    procedure WMMBUTTONDOWN(var Msg: TWMMBUTTONDOWN);
    procedure WMMBUTTONUP(var Msg: TWMMBUTTONUP);
    procedure WMRBUTTONDBLCLK(var Msg: TWMRBUTTONDBLCLK);
    procedure WMRBUTTONDOWN(var Msg: TWMRBUTTONDOWN);
    procedure WMRBUTTONUP(var Msg: TWMRBUTTONUP);
    procedure WMMOUSEMOVE(var Msg: TWMMOUSEMOVE);
  protected
    procedure  CreateWnd; override;
  public
    constructor Create(AOwner: TComponent); override;
    destructor  Destroy; override;
    property    Handle_ProgressBar :integer read hProg;   //vOXo[̃nh(Self.Handle̎qEChE)
    procedure   StepIt;
    procedure   StepBy(Delta: Word);
  published
    property BackColor : TColor read FBackColor write SetBackColor;
    property BarColor  : TColor read FBarColor  write SetBarColor;
    property Min: Word read GetMin write SetMin;
    property Max: Word read GetMax write SetMax;
    property Position: Word read GetPosition write SetPosition ;
    property Step: Word read FStep write SetStep ;
    property ProgressStyle : TProgressStyle Read FProgressStyle write SetProgressStyle;
    property Smooth : Boolean Read FSmooth write SetSmooth;
    property Align;
    property DragCursor;
    property DragMode;
    property Enabled;
    property Hint;
    property ParentShowHint;
    property PopupMenu;
    property ShowHint;
    property TabOrder;
    property TabStop;
    property Visible;
    property OnMouseDown;
    property OnMouseMove;
    property OnMouseUp;

  end;


procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('PAPY', [TColorProgressBar]);
end;


////////////////////////////////////////////////////////////////////////////////


///////////
constructor TColorProgressBar.Create(AOwner: TComponent);
begin
  inherited Create(AOwner);
  Width := 150;
  Height := GetSystemMetrics(SM_CYVSCROLL);
  FBackColor :=clRed;
  FBarColor  :=clYellow;
  FProgressStyle :=psHorizontal;
  Fmax :=100;
  FMin :=0;
  FPOsition :=0;
  FStep :=10;
end;

/////////
procedure TColorProgressBar.CreateWnd;
var
 Prog   :TInitCommonControlsEx;
 dwFlag :integer;
begin
 inherited CreateWnd;

 Prog.dwSize :=Sizeof(Prog);
 Prog.dwICC  :=ICC_PROGRESS_CLASS;
 InitCommonControlsEx(prog);

 dwFlag :=  WS_VISIBLE or WS_CHILD;

 if FProgressStyle=psVertical then  dwFlag := dwFlag or PBS_VERTICAL;
 if FSmooth then dwFlag :=dwFlag or PBS_SMOOTH;

 hProg:=CreateWindowEx(0,PROGRESS_CLASS,'',dwFlag, 0,0,Width,Height,Self.handle,0,HInstance,nil);

 SendMessage(hProg, PBM_SETRANGE, 0, MakeLong(FMin, Fmax));
 SendMessage(hProg, PBM_SETSTEP, FStep, 0);
 SendMessage(hProg, PBM_SETBARCOLOR, 0,FBarColor);
 SendMessage(hProg, PBM_SETBKCOLOR, 0,FBackColor);
 SendMessage(hProg, PBM_SETPOS, FPosition, 0);
 //Cxg擾̂邽߃TuNX
 if not (csDesigning in ComponentState) then
 begin
     FHookWndProc := MakeObjectInstance(HookWndProc );
     FAddress :=Pointer(SetWindowLong(hProg, GWL_WNDPROC, Longint( FHookWndProc ))) ;
 end;
end;

//////////
destructor TColorProgressBar.Destroy;
begin
  SetWindowLong(hProg,GWL_WNDPROC,Longint(FAddress));
  FreeObjectInstance(FHookWndProc);
  DestroyWindow(hProg);
  inherited Destroy;
end;

/////////
procedure TColorProgressBar.SetBarColor(Value :TColor);
begin
   FBarColor :=Value;
   SendMessage(hProg, PBM_SETBARCOLOR, 0,Value);
end;

/////////
procedure TColorProgressBar.SetBackColor(Value :TColor);
begin
   FBackColor :=Value;
   SendMessage(hProg, PBM_SETBKCOLOR, 0,Value);
end;

//////////
procedure TColorProgressBar.SetProgressStyle(Value :TProgressStyle);
Var
 Buffer :integer;
begin
  if  FProgressStyle<> Value then
  begin
    FProgressStyle :=Value;
    if hProg=0 then Exit;

    if (csDesigning in ComponentState) then
    begin
     SetWindowLong(hProg,GWL_WNDPROC,Longint(FAddress));
     FreeObjectInstance(FHookWndProc);
    end;

    DestroyWindow(hProg);
    RecreateWnd;
    Buffer :=Self.Height;
    Self.Height := Self.Width;
    Self.Width  :=Buffer;
  end;
end;

/////////
procedure TColorProgressBar.SetSmooth(Value: Boolean);
begin
  if  FSmooth<> Value then
  begin
    FSmooth :=Value;
    if hProg=0 then Exit;

    if (csDesigning in ComponentState) then
    begin
     SetWindowLong(hProg,GWL_WNDPROC,Longint(FAddress));
     FreeObjectInstance(FHookWndProc);
    end;

    DestroyWindow(hProg);
    RecreateWnd;
 end;

end;

////////
function TColorProgressBar.GetMin: Word;
begin
   if hProg<>0 then
     Result := SendMessage(hprog, PBM_GetRange, 1, 0)
   else
     Result :=FMin;
end;

////////
function TColorProgressBar.GetMax: Word;
begin
   if hProg<>0 then
     Result := SendMessage(hProg, PBM_GetRange, 0, 0)
   else
     Result :=FMAx;
end;

////////
function TColorProgressBar.GetPosition: Word;
begin
   if hProg<>0 then
     Result := SendMessage(hProg, PBM_GETPOS, 0, 0)
   else
     Result :=FPosition;
end;

/////////
procedure TColorProgressBar.SetMin(Value: Word);
begin
  SetParams(Value, FMax);
end;

/////////
procedure TColorProgressBar.SetMax(Value: Word);
begin
  SetParams(FMin, Value);
end;

/////////
procedure TColorProgressBar.SetPosition(Value: Word);
begin
  if hProg<>0 then
  begin
    if Value<SendMessage(hProg, PBM_GetRange, 1, 0) then Exit;
    if Value>SendMessage(hProg, PBM_GetRange, 0, 0) then Exit;
  end;
  SendMessage(hProg, PBM_SETPOS, Value, 0);
  FPosition := Value;
end;

/////////
procedure TColorProgressBar.SetParams(AMin, AMax: Word);
begin
  if AMax < AMin then  Exit;

  if hProg<>0 then
  begin
      if AMin> SendMessage(hProg, PBM_GETPOS, 0, 0)  then FPosition :=AMin;
      if AMax< SendMessage(hProg, PBM_GETPOS, 0, 0)  then FPosition :=Amax;
  end;

  if (FMin <> AMin) or (FMax <> AMax) then
  begin
     SendMessage(hProg, PBM_SETRANGE32, AMin, AMax) ;
     if FMin > AMin then SendMessage(hProg, PBM_SETPOS, AMin, 0);
  end;

    FMin := AMin;
    FMax := AMax;
end;

/////////
procedure TColorProgressBar.SetStep(Value: Word);
begin
  if Value <> FStep then
  begin
    FStep := Value;
    SendMessage(hProg, PBM_SETSTEP, FStep, 0);
  end;
end;

/////////
procedure TColorProgressBar.StepIt;
begin
  SendMessage(hProg, PBM_STEPIT, 0, 0);
end;

/////////
procedure TColorProgressBar.StepBy(Delta: Word);
begin
   SendMessage(hProg, PBM_DELTAPOS, Delta, 0);
end;


//bZ[W--------------------------------------------------------------------

/////////
procedure TColorProgressBar.HookWndProc( var Msg:TMessage );
begin
   //Ɩʓ|Ȃ̂Ń}EXñCxg܂B߂Ȃ(^^G
   case Msg.Msg of
         WM_LBUTTONDBLCLK	: WMLBUTTONDBLCLK(TWMLBUTTONDBLCLK(Msg));
         WM_LBUTTONDOWN         : WMLBUTTONDOWN(TWMLBUTTONDOWN(Msg));
         WM_LBUTTONUP           : WMLBUTTONUP(TWMLBUTTONUP(Msg));

         WM_MBUTTONDBLCLK       : WMMBUTTONDBLCLK(TWMMBUTTONDBLCLK(Msg));
         WM_MBUTTONDOWN         : WMMBUTTONDOWN(TWMMBUTTONDOWN(Msg));
         WM_MBUTTONUP           : WMMBUTTONUP(TWMMBUTTONUP(Msg));

         WM_RBUTTONDBLCLK       : WMRBUTTONDBLCLK(TWMRBUTTONDBLCLK(Msg));
         WM_RBUTTONDOWN         : WMRBUTTONDOWN(TWMRBUTTONDOWN(Msg));
         WM_RBUTTONUP           : WMRBUTTONUP(TWMRBUTTONUP(Msg));

         WM_MOUSEMOVE	        : WMMOUSEMOVE(TWMMOUSEMOVE(Msg));
   end;

   with Msg do
   begin
      Result := CallWindowProc(FAddress ,hProg,Msg,WParam,LParam );
   end;
end;

/////////
procedure TColorProgressBar.WMSize(var Msg: TWMSize);
begin
 SetWindowPos(hProg,HWND_TOP,0,0,Msg.Width,Msg.Height,SWP_FRAMECHANGED or SWP_SHOWWINDOW);
end;

/////////
procedure TColorProgressBar.WMLBUTTONDBLCLK(var Msg: TWMLBUTTONDBLCLK);
Var
 Shift : TShiftState ;
begin
 //ssAltssDouble͏ȗĒ܂B
 if Msg.Keys=MK_CONTROL	 then  Shift:= Shift+[ssCtrl];
 if Msg.Keys=MK_LBUTTON	 then  Shift:= Shift+[ssLeft]	;
 if Msg.Keys=MK_MBUTTON	 then  Shift:= Shift+[ssMiddle]	;
 if Msg.Keys=MK_RBUTTON	 then  Shift:= Shift+[ssRight]	;
 if Msg.Keys=MK_SHIFT	 then  Shift:= Shift+[ssShift]	;
 Self.MouseDown(mbLeft,Shift,Msg.XPos,Msg.YPos);
end;

/////////
procedure TColorProgressBar.WMLBUTTONDOWN(var Msg: TWMLBUTTONDOWN);
Var
 Shift : TShiftState ;
begin
 //ssAltssDouble͏ȗĒ܂B
 if Msg.Keys=MK_CONTROL	 then  Shift:= Shift+[ssCtrl];
 if Msg.Keys=MK_LBUTTON	 then  Shift:= Shift+[ssLeft]	;
 if Msg.Keys=MK_MBUTTON	 then  Shift:= Shift+[ssMiddle]	;
 if Msg.Keys=MK_RBUTTON	 then  Shift:= Shift+[ssRight]	;
 if Msg.Keys=MK_SHIFT	 then  Shift:= Shift+[ssShift]	;
 Self.MouseDown(mbLeft,Shift,Msg.XPos,Msg.YPos);
end;

/////////
procedure TColorProgressBar.WMLBUTTONUP(var Msg: TWMLBUTTONUP);
Var
 Shift : TShiftState ;
begin
 //ssAltssDouble͏ȗĒ܂B
 if Msg.Keys=MK_CONTROL	 then  Shift:= Shift+[ssCtrl];
 if Msg.Keys=MK_LBUTTON	 then  Shift:= Shift+[ssLeft]	;
 if Msg.Keys=MK_MBUTTON	 then  Shift:= Shift+[ssMiddle]	;
 if Msg.Keys=MK_RBUTTON	 then  Shift:= Shift+[ssRight]	;
 if Msg.Keys=MK_SHIFT	 then  Shift:= Shift+[ssShift]	;
 Self.MouseUp(mbLeft,Shift,Msg.XPos,Msg.YPos);
end;

/////////
procedure TColorProgressBar.WMMBUTTONDBLCLK(var Msg: TWMMBUTTONDBLCLK);
Var
 Shift : TShiftState ;
begin
 //ssAltssDouble͏ȗĒ܂B
 if Msg.Keys=MK_CONTROL	 then  Shift:= Shift+[ssCtrl];
 if Msg.Keys=MK_LBUTTON	 then  Shift:= Shift+[ssLeft]	;
 if Msg.Keys=MK_MBUTTON	 then  Shift:= Shift+[ssMiddle]	;
 if Msg.Keys=MK_RBUTTON	 then  Shift:= Shift+[ssRight]	;
 if Msg.Keys=MK_SHIFT	 then  Shift:= Shift+[ssShift]	;
 Self.MouseUp(mbMiddle,Shift,Msg.XPos,Msg.YPos);
end;

/////////
procedure TColorProgressBar.WMMBUTTONDOWN(var Msg: TWMMBUTTONDOWN);
Var
 Shift : TShiftState ;
begin
 //ssAltssDouble͏ȗĒ܂B
 if Msg.Keys=MK_CONTROL	 then  Shift:= Shift+[ssCtrl];
 if Msg.Keys=MK_LBUTTON	 then  Shift:= Shift+[ssLeft]	;
 if Msg.Keys=MK_MBUTTON	 then  Shift:= Shift+[ssMiddle]	;
 if Msg.Keys=MK_RBUTTON	 then  Shift:= Shift+[ssRight]	;
 if Msg.Keys=MK_SHIFT	 then  Shift:= Shift+[ssShift]	;
 Self.MouseDown(mbMiddle,Shift,Msg.XPos,Msg.YPos);
end;

/////////
procedure TColorProgressBar.WMMBUTTONUP(var Msg: TWMMBUTTONUP);
Var
 Shift : TShiftState ;
begin
 //ssAltssDouble͏ȗĒ܂B
 if Msg.Keys=MK_CONTROL	 then  Shift:= Shift+[ssCtrl];
 if Msg.Keys=MK_LBUTTON	 then  Shift:= Shift+[ssLeft]	;
 if Msg.Keys=MK_MBUTTON	 then  Shift:= Shift+[ssMiddle]	;
 if Msg.Keys=MK_RBUTTON	 then  Shift:= Shift+[ssRight]	;
 if Msg.Keys=MK_SHIFT	 then  Shift:= Shift+[ssShift]	;
 Self.MouseUp(mbMiddle,Shift,Msg.XPos,Msg.YPos);
end;

/////////
procedure TColorProgressBar.WMRBUTTONDBLCLK(var Msg: TWMRBUTTONDBLCLK);
Var
 Shift : TShiftState ;
begin
 //ssAltssDouble͏ȗĒ܂B
 if Msg.Keys=MK_CONTROL	 then  Shift:= Shift+[ssCtrl];
 if Msg.Keys=MK_LBUTTON	 then  Shift:= Shift+[ssLeft]	;
 if Msg.Keys=MK_MBUTTON	 then  Shift:= Shift+[ssMiddle]	;
 if Msg.Keys=MK_RBUTTON	 then  Shift:= Shift+[ssRight]	;
 if Msg.Keys=MK_SHIFT	 then  Shift:= Shift+[ssShift]	;
 Self.MouseDown(mbRight,Shift,Msg.XPos,Msg.YPos);
end;

/////////
procedure TColorProgressBar.WMRBUTTONDOWN(var Msg: TWMRBUTTONDOWN);
Var
 Shift : TShiftState ;
begin
 //ssAltssDouble͏ȗĒ܂B
 if Msg.Keys=MK_CONTROL	 then  Shift:= Shift+[ssCtrl];
 if Msg.Keys=MK_LBUTTON	 then  Shift:= Shift+[ssLeft]	;
 if Msg.Keys=MK_MBUTTON	 then  Shift:= Shift+[ssMiddle]	;
 if Msg.Keys=MK_RBUTTON	 then  Shift:= Shift+[ssRight]	;
 if Msg.Keys=MK_SHIFT	 then  Shift:= Shift+[ssShift]	;
 Self.MouseDown(mbRight,Shift,Msg.XPos,Msg.YPos);
end;

/////////
procedure TColorProgressBar.WMRBUTTONUP(var Msg: TWMRBUTTONUP);
Var
 Shift : TShiftState ;
begin
 //ssAltssDouble͏ȗĒ܂B
 if Msg.Keys=MK_CONTROL	 then  Shift:= Shift+[ssCtrl];
 if Msg.Keys=MK_LBUTTON	 then  Shift:= Shift+[ssLeft]	;
 if Msg.Keys=MK_MBUTTON	 then  Shift:= Shift+[ssMiddle]	;
 if Msg.Keys=MK_RBUTTON	 then  Shift:= Shift+[ssRight]	;
 if Msg.Keys=MK_SHIFT	 then  Shift:= Shift+[ssShift]	;
 Self.MouseUp(mbRight,Shift,Msg.XPos,Msg.YPos);
end;

/////////
procedure TColorProgressBar.WMMOUSEMOVE(var Msg: TWMMOUSEMOVE);
Var
 Shift : TShiftState ;
begin
 //ssAltssDouble͏ȗĒ܂B
 if Msg.Keys=MK_CONTROL	 then  Shift:= Shift+[ssCtrl];
 if Msg.Keys=MK_LBUTTON	 then  Shift:= Shift+[ssLeft]	;
 if Msg.Keys=MK_MBUTTON	 then  Shift:= Shift+[ssMiddle]	;
 if Msg.Keys=MK_RBUTTON	 then  Shift:= Shift+[ssRight]	;
 if Msg.Keys=MK_SHIFT	 then  Shift:= Shift+[ssShift]	;
  Self.MouseMOve(Shift,Msg.XPos,Msg.YPos);
end;

end.
